\ init.f - 32-bit initialization                24 Oct 1999  tcn

USE16
'i $E00 + # AX MOV,  7 # BX MOV,  10 INT,  \ DEBUGGING MESSAGE

HEX
JMP-FROM init:  \ Jump past the realmode subroutines









\ Support routines
LABEL: delay
  ret,

LABEL: empty_8042  \ flush kbd controller
  BEGIN,
    delay # call,  64 # al in,  1 # al test,
    0=, NOT, IF,
      delay # call,  60 # al in,  empty_8042 jmp,
    THEN,
  2 # al test,  0=, UNTIL,  RET,





\ Enable A20 line so we can address above 1M
LABEL: enable-A20
  D1 # al mov, 64 # al out, empty_8042 # call,
  DF # al mov, 60 # al out, empty_8042 # call,
  ds push, ax ax xor, ax ds mov, ( DS = 0000)
  ax dec, ax gs mov,             ( GS = FFFF)
  7C #@ bx mov,
  BEGIN,
    ax inc,  ax 7C #@ mov,  gs: 8C #@ ax cmp,  0=, NOT,
  UNTIL,
  bx 7C #@ mov,
  ds pop,  ret,




\ Reprogram 8259 interrupt controller
LABEL: reprogram-PIC
  11 # al mov,  20 # al out,  A0 # al out,   \ init 8259
  20 # al mov,  21 # al out,   \ base interrupt vector
  28 # al mov,  A1 # al out,   \ "
  4 # al mov,   21 # al out,   \ Cascade on irq2
  2 # al mov,   A1 # al out,   \ "
  1 # al mov,   21 # al out,  A1 # al out,   \ finish init
  FF # al mov,  21 # al out,  A1 # al out,   \ mask all ints
  ret,






\ GDT
4 0ALIGN,  LABEL: GDT0    0 dd, 0 dd,
  FFFF dw, 0000 dw, 9A00 dw, 00CF dw,
  FFFF dw, 0000 dw, 9200 dw, 00CF dw,
  FFFF dw, 0000 dw, FA00 dw, 00CF dw,
  FFFF dw, 0000 dw, F200 dw, 00CF dw,

LABEL: GDTR       $ GDT0 - dw,  ( size)
                  GDT dd, ( address)

LABEL: build-GDT   \ Copy GDT template to final location
  GDT 4 RSHIFT # ax mov,  ax es mov,  di di xor, ( dest)
  GDT0 # si mov, ( source)
  GDTR #@ cx mov,  1 # cx shr, ( count)
  cld,  rep w-ptr movs,  ret,

\ IDT
LABEL: ISR0   ( anything on stack? I forget)  IRET,

LABEL: IDT0   ISR0 dw, 8 dw,  0 db, 8E db,
              ISR0 10 RSHIFT dw,

LABEL: IDTR   800 dw, ( size)   IDT dd, ( address)

LABEL: build-IDT  \ 256 entries w/ dummy interrupt handler
  IDT 4 RSHIFT # ax mov,  ax es mov,
  di di xor,  100 # cx mov,  cld,
  begin,
    IDT0 # SI MOV,
    W-PTR MOVS,  W-PTR MOVS,  W-PTR MOVS,  W-PTR MOVS,
  loop,  ret,

\ Main init routine
init: JMP-TO    \ prepare for protected mode...
  CS PUSH, DS POP,
  305 # ax mov,  bx bx xor,  16 int,  ( kbd repeat rate = fast)
  build-GDT # call,
  build-IDT # call,
  reprogram-PIC # call,
  enable-A20 # call,








\ Jump to protected mode code:
  cli,
  0F db, 01 db, 16 db, GDTR dw,  ( GDTR #@ lgdt, )
  0F db, 01 db, 1E db, IDTR dw,  ( IDTR #@ lidt, )
  0F db, 20 db, C0 db,  ( cr0 eax mov, )
  eax inc,
  0F db, 22 db, C0 db,  ( eax cr0 mov, )
  opsiz:  EA db, ( JMP FAR)
          LABEL' jump32:  0 dd,  8 dw, ( CS selector)

\ END
\ Drivers & Forth follow...




